import javax.swing.*;
import java.beans.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import java.text.*;

import CH.psi.midas.*;
import com.symantec.itools.javax.swing.borders.BevelBorder;

public class JPanelStatus extends javax.swing.JPanel implements ActionListener, MessageListener, OdbKeyUpdate
{
    // Member variables
    private Experiment experiment;
    
	private OdbKey startTimeBinary, stopTimeAscii, writeData, clientNotify;
	private Timer stopTimer;
	private long timeOffset;
	private Runnable doScroll;
	
	private Vector vecChan = new Vector();
	private Vector vecActive = new Vector();
	private Vector vecFe = new Vector();
	private Vector vecEquip = new Vector();

    private boolean loggerRunning;
    private boolean analyzerRunning;
    
    private Vector vecMessages;
    
    private int lastMessage;
    private String messageSender;

	public JPanelStatus()
	{

		//{{INIT_CONTROLS
		setLayout(new GridBagLayout());
		Insets ins = getInsets();
		setSize(430,270);
		JPanelRuninfo.setLayout(new GridBagLayout());
		add(JPanelRuninfo,new com.symantec.itools.awt.GridBagConstraintsD(0,0,1,1,1.0,0.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.HORIZONTAL,new Insets(0,0,0,0),0,0));
		JPanelRuninfo.setBounds(0,0,430,23);
		runState.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		runState.setText("State");
		runState.setOdbPath("/runinfo/state");
		runState.setOpaque(true);
		runState.setBorder(bevelBorder1);
		JPanelRuninfo.add(runState, new com.symantec.itools.awt.GridBagConstraintsD(0,0,1,1,0.25,1.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.HORIZONTAL,new Insets(0,0,0,0),0,0));
		runState.setForeground(java.awt.Color.black);
		runState.setBounds(0,0,95,4);
		runNumber.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
		runNumber.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		runNumber.setText("Run #");
		runNumber.setOdbPath("/runinfo/run number");
		runNumber.setBorder(bevelBorder1);
		JPanelRuninfo.add(runNumber, new com.symantec.itools.awt.GridBagConstraintsD(1,0,1,1,0.25,1.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.HORIZONTAL,new Insets(0,0,0,0),0,0));
		runNumber.setBounds(95,0,95,4);
		dataDir.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		dataDir.setText("Data Dir");
		dataDir.setOdbPath("/Logger/Data dir");
		dataDir.setBorder(bevelBorder1);
		JPanelRuninfo.add(dataDir, new com.symantec.itools.awt.GridBagConstraintsD(2,0,1,1,0.5,1.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.HORIZONTAL,new Insets(0,0,0,0),0,0));
		dataDir.setBounds(190,0,240,4);
		startTime.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		startTime.setText("Start time");
		startTime.setOdbPath("/Runinfo/Start time");
		startTime.setBorder(bevelBorder1);
		JPanelRuninfo.add(startTime, new com.symantec.itools.awt.GridBagConstraintsD(0,1,2,1,0.5,1.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.HORIZONTAL,new Insets(0,0,0,0),0,0));
		startTime.setBounds(0,11,190,4);
		labelStopTime.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		labelStopTime.setText("Stop time");
		labelStopTime.setBorder(bevelBorder1);
		JPanelRuninfo.add(labelStopTime, new com.symantec.itools.awt.GridBagConstraintsD(2,1,1,1,0.5,1.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.HORIZONTAL,new Insets(0,0,0,0),0,0));
		labelStopTime.setBounds(190,4,240,19);
		JPanelEquip.setBorder(bevelBorder1);
		JPanelEquip.setLayout(new GridBagLayout());
		add(JPanelEquip,new com.symantec.itools.awt.GridBagConstraintsD(0,1,1,1,1.0,0.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.HORIZONTAL,new Insets(0,0,0,0),0,0));
		JPanelEquip.setBounds(0,23,430,19);
		JLabel1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		JLabel1.setText("Equipment");
		JPanelEquip.add(JLabel1, new com.symantec.itools.awt.GridBagConstraintsD(0,0,1,1,0.1666,1.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.HORIZONTAL,new Insets(0,0,0,0),0,0));
		JLabel1.setForeground(java.awt.Color.black);
		JLabel1.setBounds(2,2,71,15);
		JLabel2.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		JLabel2.setText("FE Node");
		JPanelEquip.add(JLabel2, new com.symantec.itools.awt.GridBagConstraintsD(1,0,1,1,0.1666,1.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.HORIZONTAL,new Insets(0,0,0,0),0,0));
		JLabel2.setForeground(java.awt.Color.black);
		JLabel2.setBounds(73,2,56,15);
		JLabel3.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		JLabel3.setText("Events");
		JPanelEquip.add(JLabel3, new com.symantec.itools.awt.GridBagConstraintsD(2,0,1,1,0.1666,1.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.HORIZONTAL,new Insets(0,0,0,0),0,0));
		JLabel3.setForeground(java.awt.Color.black);
		JLabel3.setBounds(129,2,49,15);
		JLabel4.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		JLabel4.setText("Event rate [/s]");
		JPanelEquip.add(JLabel4, new com.symantec.itools.awt.GridBagConstraintsD(3,0,1,1,0.1666,1.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.HORIZONTAL,new Insets(0,0,0,0),0,0));
		JLabel4.setForeground(java.awt.Color.black);
		JLabel4.setBounds(178,2,89,15);
		JLabel5.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		JLabel5.setText("Data rate [kB/s]");
		JPanelEquip.add(JLabel5, new com.symantec.itools.awt.GridBagConstraintsD(4,0,1,1,0.1666,1.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.HORIZONTAL,new Insets(0,0,0,0),0,0));
		JLabel5.setForeground(java.awt.Color.black);
		JLabel5.setBounds(267,2,99,15);
		JLabel6.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		JLabel6.setText("Analyzed");
		JPanelEquip.add(JLabel6, new com.symantec.itools.awt.GridBagConstraintsD(5,0,1,1,0.1666,1.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.HORIZONTAL,new Insets(0,0,0,0),0,0));
		JLabel6.setForeground(java.awt.Color.black);
		JLabel6.setBounds(366,2,62,15);
		JPanelChannels.setBorder(bevelBorder1);
		JPanelChannels.setLayout(new GridBagLayout());
		add(JPanelChannels, new com.symantec.itools.awt.GridBagConstraintsD(0,2,1,1,1.0,0.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.HORIZONTAL,new Insets(0,0,0,0),0,0));
		JPanelChannels.setBounds(0,42,430,19);
		JLabel7.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		JLabel7.setText("Channel");
		JPanelChannels.add(JLabel7, new com.symantec.itools.awt.GridBagConstraintsD(0,0,1,1,0.2,1.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.HORIZONTAL,new Insets(0,0,0,0),0,0));
		JLabel7.setForeground(java.awt.Color.black);
		JLabel7.setBounds(3,2,86,15);
		JLabel8.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		JLabel8.setText("Active");
		JPanelChannels.add(JLabel8, new com.symantec.itools.awt.GridBagConstraintsD(1,0,1,1,0.2,1.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.HORIZONTAL,new Insets(0,0,0,0),0,0));
		JLabel8.setForeground(java.awt.Color.black);
		JLabel8.setBounds(89,2,75,15);
		JLabel9.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		JLabel9.setText("Events");
		JPanelChannels.add(JLabel9, new com.symantec.itools.awt.GridBagConstraintsD(2,0,1,1,0.2,1.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.HORIZONTAL,new Insets(0,0,0,0),0,0));
		JLabel9.setForeground(java.awt.Color.black);
		JLabel9.setBounds(164,2,78,15);
		JLabel10.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		JLabel10.setText("MB written");
		JPanelChannels.add(JLabel10, new com.symantec.itools.awt.GridBagConstraintsD(3,0,1,1,0.2,1.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.HORIZONTAL,new Insets(0,0,0,0),0,0));
		JLabel10.setForeground(java.awt.Color.black);
		JLabel10.setBounds(242,2,101,15);
		JLabel11.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		JLabel11.setText("GB total");
		JPanelChannels.add(JLabel11, new com.symantec.itools.awt.GridBagConstraintsD(4,0,1,1,0.2,1.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.HORIZONTAL,new Insets(0,0,0,0),0,0));
		JLabel11.setForeground(java.awt.Color.black);
		JLabel11.setBounds(343,2,84,15);
		JPanelMessages.setLayout(new BorderLayout(0,0));
		add(JPanelMessages, new com.symantec.itools.awt.GridBagConstraintsD(0,3,1,1,1.0,1.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.BOTH,new Insets(0,0,0,0),0,0));
		JPanelMessages.setBounds(0,61,430,190);
		JScrollPane1.setOpaque(true);
		JPanelMessages.add(BorderLayout.CENTER,JScrollPane1);
		JScrollPane1.setBounds(0,0,430,190);
		JScrollPane1.getViewport().add(JListMessages);
		JListMessages.setBounds(0,0,427,187);
		//$$ bevelBorder1.move(0,271);
		add(JTextFieldMsg, new com.symantec.itools.awt.GridBagConstraintsD(0,4,1,1,1.0,0.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.HORIZONTAL,new Insets(0,0,0,0),0,0));
		JTextFieldMsg.setBounds(0,251,430,19);
		//}}

		//{{REGISTER_LISTENERS
		//}}
	}

	//{{DECLARE_CONTROLS
	javax.swing.JPanel JPanelRuninfo = new javax.swing.JPanel();
	CH.psi.midas.MJLabel runState = new CH.psi.midas.MJLabel();
	CH.psi.midas.MJLabel runNumber = new CH.psi.midas.MJLabel();
	CH.psi.midas.MJLabel dataDir = new CH.psi.midas.MJLabel();
	CH.psi.midas.MJLabel startTime = new CH.psi.midas.MJLabel();
	javax.swing.JLabel labelStopTime = new javax.swing.JLabel();
	javax.swing.JPanel JPanelEquip = new javax.swing.JPanel();
	javax.swing.JLabel JLabel1 = new javax.swing.JLabel();
	javax.swing.JLabel JLabel2 = new javax.swing.JLabel();
	javax.swing.JLabel JLabel3 = new javax.swing.JLabel();
	javax.swing.JLabel JLabel4 = new javax.swing.JLabel();
	javax.swing.JLabel JLabel5 = new javax.swing.JLabel();
	javax.swing.JLabel JLabel6 = new javax.swing.JLabel();
	javax.swing.JPanel JPanelChannels = new javax.swing.JPanel();
	javax.swing.JLabel JLabel7 = new javax.swing.JLabel();
	javax.swing.JLabel JLabel8 = new javax.swing.JLabel();
	javax.swing.JLabel JLabel9 = new javax.swing.JLabel();
	javax.swing.JLabel JLabel10 = new javax.swing.JLabel();
	javax.swing.JLabel JLabel11 = new javax.swing.JLabel();
	javax.swing.JPanel JPanelMessages = new javax.swing.JPanel();
	javax.swing.JScrollPane JScrollPane1 = new javax.swing.JScrollPane();
	javax.swing.JList JListMessages = new javax.swing.JList();
	com.symantec.itools.javax.swing.borders.BevelBorder bevelBorder1 = new com.symantec.itools.javax.swing.borders.BevelBorder();
	javax.swing.JTextField JTextFieldMsg = new javax.swing.JTextField();
	//}}

    
    public void connect(Experiment experiment) throws 
                  IOException,TooManyListenersException,OdbKeyNotFoundException {
      this.experiment = experiment;
      
      // check running programs
      loggerRunning = experiment.isClient("Logger", true);
      analyzerRunning = experiment.isClient("Analyzer", true);

      // get write data flag
      writeData = new OdbKey(experiment, "/Logger/Write data");
      writeData.hotLink(new OdbKeyUpdate() {
        public void update(OdbKey k) {
          for (int i=0 ; i<vecActive.size() ; i++)
            ((MJLabel)vecActive.elementAt(i)).reformat();
        }});
      
      // establish formatter
      runNumber.addFormatter(new OdbKeyFormatter() {
        public String format(String data, MJLabel l) {
          return "Run #"+data;
        }});
      
      runState.addFormatter(new OdbKeyFormatter() {
        public String format(String data, MJLabel l) {
          if (data.equals("1")) {
            l.setBackground(Color.red);
            return "Stopped";
          } else if (data.equals("2")) {
            l.setBackground(Color.yellow);
            return "Paused";
          } else if (data.equals("3")) {
            l.setBackground(Color.green);
            return "Running";
          } 
          return "Unknown";
        }});

      dataDir.addFormatter(new OdbKeyFormatter() {
        public String format(String data, MJLabel l) {
          return "Data dir: "+data;
        }});

      startTime.addFormatter(new OdbKeyFormatter() {
        public String format(String data, MJLabel l) {
          return "Start: "+data;
        }});
      
      runNumber.connect(experiment);
      runState.connect(experiment);
      dataDir.connect(experiment);
      startTime.connect(experiment);
      
      // add listener for run number change
      runNumber.addPropertyChangeListener(new PropertyChangeListener() {
        public void propertyChange(PropertyChangeEvent e) {
            for (int i=0 ; i<vecChan.size() ; i++) {
              MJLabel l = (MJLabel)vecChan.elementAt(i);
              l.reformat();
            }
          };
        });
      
      // create timer for stop time
      stopTimeAscii = new OdbKey(experiment, "/Runinfo/Stop time");
      stopTimeAscii.hotLink();
      startTimeBinary = new OdbKey(experiment, "/Runinfo/Start time binary");
      startTimeBinary.hotLink();
      stopTimer = new Timer(1000, this);
      
      String r = experiment.rpcCall("cm_time");
      timeOffset = new Date().getTime() - 
                        (long)Integer.parseInt(experiment.replyParam(r, 1))*1000;
                        
      // enumerate equipment
      
      OdbKey keyEquip;
      GridBagConstraints g = new GridBagConstraints();
      g.gridwidth = g.gridheight = 1;
      g.weightx = 0.1666;
      g.weighty = 1;
      g.anchor = GridBagConstraints.CENTER;
      g.fill = GridBagConstraints.HORIZONTAL;
      g.ipadx = g.ipady = 0;
      for (int i=0 ; ; i++) {
         
        // Equipment name
        keyEquip = experiment.enumOdbKey("/Equipment", i);
        if (keyEquip == null)
          break;
        JLabel l = new JLabel(keyEquip.getName());
		l.setHorizontalAlignment(SwingConstants.LEFT);
		l.setForeground(Color.blue);
        g.gridx = 0;
        g.gridy = 1+i;
        g.insets = new Insets(0, 10, 0, 0);
        JPanelEquip.add(l, g); 
        vecEquip.addElement(l);
         
        // FE Node
        String feName = experiment.getOdbValue("/Equipment/"+keyEquip.getName()+"/Common/Frontend name");
        if (experiment.isClient(feName, true)) {
          String feHost = experiment.getOdbValue("/Equipment/"+keyEquip.getName()+"/Common/Frontend host");
          l = new JLabel(feHost);
          l.setBackground(Color.green);
        } else {
          l = new JLabel("(inactive)");
          l.setBackground(Color.red);
        }
        l.setHorizontalAlignment(SwingConstants.CENTER);
        l.setOpaque(true);
        l.setForeground(Color.black);
        g.gridx = 1;
        g.insets = new Insets(0, 0, 0, 0);
        JPanelEquip.add(l, g);
        vecFe.addElement(l);
         
        // Events
        MJLabel ml = new MJLabel("/Equipment/"+keyEquip.getName()+"/Statistics/Events sent");
        ml.connect(experiment);
        ml.setHorizontalAlignment(SwingConstants.CENTER);
        g.gridx = 2;
        JPanelEquip.add(ml, g);

        // Events /s
        ml = new MJLabel("/Equipment/"+keyEquip.getName()+"/Statistics/Events per sec.");
        ml.connect(experiment);
        ml.setHorizontalAlignment(SwingConstants.CENTER);
        g.gridx = 3;
        JPanelEquip.add(ml, g);

        // kB /s
        ml = new MJLabel("/Equipment/"+keyEquip.getName()+"/Statistics/kBytes per sec.");
        ml.addFormatter(new OdbKeyFormatter() {
        public String format(String data, MJLabel l) {
          DecimalFormat df = new DecimalFormat("0.000");
          return df.format(new Double(data).doubleValue());
        }});
        ml.connect(experiment);
        ml.setHorizontalAlignment(SwingConstants.CENTER);
        g.gridx = 4;
        JPanelEquip.add(ml, g);
         
        // Analyzed
        g.gridx = 5;
        try {
          ml = new MJLabel("/Analyzer/"+keyEquip.getName()+"/Statistics/Events received");
          ml.setHorizontalAlignment(SwingConstants.CENTER);
          ml.connect(experiment);
          JPanelEquip.add(ml, g);
        } catch (OdbKeyNotFoundException ex) {
          l = new JLabel("-");
          l.setHorizontalAlignment(SwingConstants.CENTER);
          JPanelEquip.add(l, g);
        }
      }

      // enumerate channels
      
      OdbKey keyChan;
      g.weightx = 0.2;
      for (int i=0 ; ; i++) {
         
        // Channel name
        keyChan = experiment.enumOdbKey("/Logger/Channels", i);
        if (keyChan == null)
          break;
        MJLabel ml = new MJLabel("/Logger/Channels/"+keyChan.getName()+"/Settings/Filename");
		ml.setHorizontalAlignment(SwingConstants.LEFT);
		ml.setForeground(Color.blue);
	    ml.addFormatter(new OdbKeyFormatter() {
	      public String format(String data, MJLabel l) {

	        // cut password etc for FTP
	        int index = data.indexOf(',');
	        if (index != -1) {
	          return data.substring(0, index);
	        }
            
            // replace %05d with run number
	        index = data.indexOf('%');
	        if (index != -1) {
	          String str = data.substring(0, index);
	          DecimalFormat df = new DecimalFormat("00000");
	          str += df.format(Integer.parseInt(runNumber.getData()));
	          str += data.substring(index+4, data.length());
	          return str;
	          }
	        return data;
	      }});
		ml.connect(experiment);
        g.gridx = 0;
        g.gridy = 1+i;
        g.insets = new Insets(0, 10, 0, 0);
        JPanelChannels.add(ml, g); 
        vecChan.addElement(ml);

        // Active
        ml = new MJLabel("/Logger/Channels/"+keyChan.getName()+"/Settings/Active");
        ml.setHorizontalAlignment(SwingConstants.CENTER);
        ml.setOpaque(true);
		ml.setForeground(Color.black);
        ml.addFormatter(new OdbKeyFormatter() {
        public String format(String data, MJLabel l) {
          if (!loggerRunning) {
            l.setBackground(Color.red);
            return "No Logger";
          }
          if (writeData.toString().equals("n")) {
            l.setBackground(Color.yellow);
            return "Disabled";
          }
          if (data.equals("y")) {
            l.setBackground(Color.green);
            return "Yes";
          } 
          if (data.equals("n")) {
            l.setBackground(Color.yellow);
            return "No";
          } 
          return "Unknown";
        }});
        ml.connect(experiment);
        g.gridx = 1;
        g.insets = new Insets(0, 0, 0, 0);
        JPanelChannels.add(ml, g);
        vecActive.addElement(ml);

        // Events
        ml = new MJLabel("/Logger/Channels/"+keyChan.getName()+"/Statistics/Events written");
        ml.connect(experiment);
        ml.setHorizontalAlignment(SwingConstants.CENTER);
        g.gridx = 2;
        JPanelChannels.add(ml, g);

        // MB written
        ml = new MJLabel("/Logger/Channels/"+keyChan.getName()+"/Statistics/Bytes written");
        ml.setHorizontalAlignment(SwingConstants.CENTER);
        ml.addFormatter(new OdbKeyFormatter() {
        public String format(String data, MJLabel l) {
          DecimalFormat df = new DecimalFormat("0.000");
          return df.format(new Double(data).doubleValue()/1024.0/1024.0);
        }});
        ml.connect(experiment);
        g.gridx = 3;
        JPanelChannels.add(ml, g);

        // GB written
        ml = new MJLabel("/Logger/Channels/"+keyChan.getName()+"/Statistics/Bytes written total");
        ml.setHorizontalAlignment(SwingConstants.CENTER);
        ml.addFormatter(new OdbKeyFormatter() {
        public String format(String data, MJLabel l) {
          DecimalFormat df = new DecimalFormat("0.000");
          return df.format(new Double(data).doubleValue()/1024.0/1024.0/1024.0);
        }});
        ml.connect(experiment);
        g.gridx = 4;
        JPanelChannels.add(ml, g);
      }
      
     
      // retrieve messages
      vecMessages = experiment.retrieveMessages();
      JListMessages.setListData(vecMessages);
      experiment.addMessageListener(this);    

      // scroll to end of messages
      doScroll = new Runnable() {
        public void run () {
            Dimension d = JListMessages.getSize();
            JListMessages.scrollRectToVisible(new Rectangle(0, d.height-1, 1, d.height));
        }
      };
 
      // add RETURN listerner to message entry field
      JTextFieldMsg.addActionListener(this);

      // start timer
      stopTimer.start();

      // hotlink system/clients key
      clientNotify = new OdbKey(experiment, "/System/Client Notify");
      clientNotify.hotLink(this);

      SwingUtilities.invokeLater(doScroll);
      }
    
    public void actionPerformed(ActionEvent e) {

      if (e.getSource() == stopTimer) {
        if (runState.getText().equals("Stopped"))
          labelStopTime.setText("Stop: "+stopTimeAscii);
        else {
          Date dstart = new Date(Long.parseLong(startTimeBinary.toString())*1000);
          long diff = new Date().getTime() - dstart.getTime() - timeOffset;
          diff /= 1000;

          int h = (int) diff/3600;
          diff = diff-h*3600;
          int m = (int) diff/60;
          diff = diff-m*60;

          DecimalFormat df = new DecimalFormat("00");
          labelStopTime.setText("Running time: "+h+"h"+
                                 df.format(m)+"m"+
                                 df.format(diff)+"s");
        }
      } else if (e.getSource() == JTextFieldMsg) {
        
        // identify sender
        int now = (int) (new Date().getTime()/1000);
        if (now - lastMessage > 600) {
          messageSender = JOptionPane.showInputDialog(this, 
                            "Please enter your nickname:" ,
                            "JMIDAS",
                            JOptionPane.PLAIN_MESSAGE);
          lastMessage = now;  
        }

        String msg = JTextFieldMsg.getText();
        JTextFieldMsg.setText("");

        try {
          experiment.messageSend(Experiment.MUSER, messageSender, msg);
        } catch (IOException ex) { System.out.println(ex); }
      }
    }
  
    public void update(OdbKey k) {
      try {
        loggerRunning = experiment.isClient("Logger", true);
        analyzerRunning = experiment.isClient("Analyzer", true);

        for (int i=0 ; i < vecActive.size() ; i++)
          ((MJLabel)vecActive.elementAt(i)).reformat();
           
        for (int i=0 ; i < vecEquip.size() ; i++) {
          JLabel l = (JLabel)vecFe.elementAt(i);
          String equipName = ((JLabel)vecEquip.elementAt(i)).getText();
          String feName = experiment.getOdbValue("/Equipment/"+equipName+"/Common/Frontend name");
          if (experiment.isClient(feName, true)) {
            String feHost = experiment.getOdbValue("/Equipment/"+equipName+"/Common/Frontend host");
            l.setText(feHost);
            l.setBackground(Color.green);
          } else {
            l.setText("(inactive)");
            l.setBackground(Color.red);
          }
        }
      }  catch (Exception ex) { System.out.println(ex); }
    }
    
    public void receiveMessage(String message) {
      
      // add current time
      Date date = new Date();
      vecMessages.addElement(date.toString().substring(11, 19)+" "+message);

      // avoid > 100 messages
      if (vecMessages.size() > 100)
        vecMessages.removeElementAt(0);

      // set new message to list control
      JListMessages.setListData(vecMessages);

      // schedule scrolling after list box has been resized
      SwingUtilities.invokeLater(doScroll);
      
    }
    
    // let the equipment panel decide about the size of the whole panel width
    public Dimension getPreferredSize() {
      Dimension d = super.getPreferredSize();
      Dimension eq = JPanelEquip.getPreferredSize();
      
      if (eq.width < d.width)
        d.width = (int) (eq.width*1.1);
        
      return d;
    }

}