// -*- C++ -*-
//
// user_inc.h
//
// Author:  Ken Sakashita
// Created: Fri Nov 29 14:52:00 JST 2002
//
// $Id: user_inc.h,v 1.3 2002/12/03 20:42:16 kensh Exp $
//
// $Log: user_inc.h,v $
// Revision 1.3  2002/12/03 20:42:16  kensh
// Add scaler info. of all channel.
//
// Revision 1.2  2002/12/01 01:09:12  kensh
// Add Veto plots and trigger eff. plot.
//
// Revision 1.1  2002/11/29 05:56:52  kensh
//
// Initial version
//
//
//

#ifndef USERINC_H_INCLUDED
#define USERINC_H_INCLUDED

//
typedef struct {
  int  ch;
  std::string name;

} SCLINFO;
SCLINFO scl[] = { { 0, "SEC Total" },
		  { 1, "SEC on-spill" },
		  { 2, "TMON Total" },
		  { 3, "TMON on-spill" },
		  { 4, "Spill End" },
		  { 5, "clock" },
		  { 6, "(CsI left)" },
		  { 7, "(CsI right)" },
		  { 8, "(CsI upper)" },
		  { 9, "(CsI lower)" },
		  { 10, "" },
		  { 11, "" },
		  { 12, "Trigger Req." },
		  { 13, "Trigger Acc." },
		  { 14, "processed event" },
		  { 15, "processed by Fe1" },
		  { 16, "processed by Fe2" },
		  { 17, "processed by Fe3" },
		  { 18, "buffer change" },
		  { 19, "buffer change by Fe1" },
		  { 20, "buffer change by Fe2" },
		  { 21, "buffer change by Fe3" },
		  { 22, "" },
		  { 23, "" },
		  { 24, "Trigger req. on-spill" },
		  { 25, "Trigger acc. on-spill" },
		  { 26, "processed event on-spill" },
		  { 27, "processed by Fe1 on-spill" },
		  { 28, "processed by Fe2 on-spill" },
		  { 29, "processed by Fe3 on-spill" },
		  { 30, "" },
		  { 31, "" },
		  { 32, "" },
		  { 33, "" },
		  { 34, "" },
		  { 35, "" },
		  { 36, "Trigger 1 Req." },
		  { 37, "Trigger 1 Acc." },
		  { 38, "Trigger 2 Req." },
		  { 39, "Trigger 2 Acc." },
		  { 40, "Trigger 3 Req." },
		  { 41, "Trigger 3 Acc." },
		  { 42, "Trigger 4 Req." },
		  { 43, "Trigger 4 Acc." },
		  { 44, "Trigger 5 Req." },
		  { 45, "Trigger 5 Acc." },
		  { 46, "Trigger 6 Req." },
		  { 47, "Trigger 6 Acc." },
		  { 48, "Trigger 7 Req." },
		  { 49, "Trigger 7 Acc." },
		  { 50, "Trigger 1 before prescale" },
		  { 51, "Trigger 2 before prescale" },
		  { 52, "Trigger 3 before prescale" },
		  { 53, "Trigger 4 before prescale" },
		  { 54, "Trigger 5 before prescale" },
		  { 55, "Trigger 6 before prescale" },
		  { 56, "Trigger 7 before prescale" },
		  { 57, "" },
		  { 58, "" },
		  { 59, "" },
		  { 60, "Trigger 1 on-spill" },
		  { 61, "Trigger 1 & acc. on-spill" },
		  { 62, "Trigger 2 on-spill" },
		  { 63, "Trigger 2 & acc. on-spill" },
		  { 64, "Trigger 3 on-spill" },
		  { 65, "Trigger 3 & acc. on-spill" },
		  { 66, "Trigger 4 on-spill" },
		  { 67, "Trigger 4 & acc. on-spill" },
		  { 68, "Trigger 5 on-spill" },
		  { 69, "Trigger 5 & acc. on-spill" },
		  { 70, "Trigger 6 on-spill" },
		  { 71, "Trigger 6 & acc. on-spill" },
		  { 72, "Trigger 7 on-spill" },
		  { 73, "Trigger 7 & acc. on-spill" },
		  { 74, "Trigger 1 before prescale on-spill" },
		  { 75, "Trigger 2 before prescale on-spill" },
		  { 76, "Trigger 3 before prescale on-spill" },
		  { 77, "Trigger 4 before prescale on-spill" },
		  { 78, "Trigger 5 before prescale on-spill" },
		  { 79, "Trigger 6 before prescale on-spill" },
		  { 80, "Trigger 7 before prescale on-spill" },
		  { 81, "" },
		  { 82, "" },
		  { 83, "" },
		  { 84, "CsI >= 1 w/o Veto" },
		  { 85, "CsI >= 2 w/o Veto" },
		  { 86, "CsI >= 3 w/o Veto" },
		  { 87, "CsI >= 4 w/o Veto" },
		  { 88, "CsI >= 5 w/o Veto" },
		  { 89, "CsI >= 6 w/o Veto" },
		  { 90, "CsI >= 1 w/ Veto" },
		  { 91, "CsI >= 2 w/ Veto" },
		  { 92, "CsI >= 3 w/ Veto" },
		  { 93, "CsI >= 4 w/ Veto" },
		  { 94, "CsI >= 5 w/ Veto" },
		  { 95, "CsI >= 6 w/ Veto" }, 
		  { 96, "CC01 sum " },
		  { 97, "CC02 sum " },
		  { 98, "CC03 sum " },
		  { 99, "CC04 sum " },
		  { 100, "CC05 sum " },
		  { 101, "ChargeVeto sum w/ inner " },
		  { 102, "ChargeVeto sum w/o inner " },
		  { 103, "Multi. Logic 01" },
		  { 104, "Multi. Logic 02" },
		  { 105, "Multi. Logic 03" },
		  { 106, "Multi. Logic 04" },
		  { 107, "Multi. Logic 05" }

};

const int nscl = sizeof(scl)/sizeof(SCLINFO);

//
#endif // USERINC_H_INCLUDED

