// -*- C++ -*-
//
// ngf_1885n.h
// utility
//
// Author:  Mitsuhiro YAMAGA (yamaga@post.kek.jp)
// Created: Mon Apr  8 21:14:27 JST 2002
//
// $Id: ngf_1885n.h,v 1.1.1.1 2002/08/13 12:48:12 kensh Exp $
//
// Revision History
//
// $Log: ngf_1885n.h,v $
// Revision 1.1.1.1  2002/08/13 12:48:12  kensh
//
//
// Start version.
//
//

#ifndef NGF_1885N_H_INCLUDED
#define NGF_1885N_H_INCLUDED

#include <iostream>
#include "ngf/Ngf.h"
#include "vmeioreg/VmeIoreg.h"


// functions
void  initSettings();
void  initNgf();
void  init1885n();
void  initNgfCommandList();
void  termNgf();
void  beginRunNgf();
void  endRunNgf();
void  pauseRunNgf();
void  resumeRunNgf();
void  bufferEventNgf();
void  fillBankNgf( char* );

#define  NGF_BUF_EMPTY  0x20
#define  NGF_LIST_MODE  0x02

// inline
inline bool
interruptedNgf()
{
  extern bool  Interrupted;
  return( Interrupted );
}

inline bool
interruptSource( int i )
{
  extern VmeIoreg  vioreg;
  return( vioreg.busy(i) );
}

inline bool
listFailedNgf()
{
  extern Ngf  ngf;
  if( !(ngf.SeqStatusReg() & NGF_LIST_MODE ) )
    return( true );
  return( false );
}

inline void
resetListNgf()
{
  extern Ngf  ngf;
  ngf.enableList();
  std::cerr << "Ngf::enableList called" << std::endl;
}


#endif // NGF_1885N_H_INCLUDED
