// -*- C++ -*-
//
// ntuple.h
// NTUPLE information
//
// Author:  Mitsuhiro YAMAGA (yamaga@post.kek.jp)
// Created: Fri Apr 20 15:44:51 JST 2001
//
// $Id: Ntuple.h,v 1.1.1.1 2002/08/13 12:48:09 kensh Exp $
//
// Revision History
//
// $Log: Ntuple.h,v $
// Revision 1.1.1.1  2002/08/13 12:48:09  kensh
//
//
// Start version.
//
//

#ifndef GSIM_GENERAL_NTUPLE_H_INCLUDED
#define GSIM_GENERAL_NTUPLE_H_INCLUDED

// User should define GEN as an input and NRESULT as an output.
// See ntuple.cc in the gsim-e391a directory.
extern void*  gen_ptr;
extern void*  nresult_ptr;
extern char*  s_nresult_ptr;


// GEN_PARTICLE
#define  MAX_GEN 20
typedef struct{
  int   NGEN;
  float XX[MAX_GEN],YY[MAX_GEN],ZZ[MAX_GEN];
  float PX[MAX_GEN],PY[MAX_GEN],PZ[MAX_GEN],PP[MAX_GEN];
  float EK[MAX_GEN],MASS[MAX_GEN];
  int   PN[MAX_GEN],MO[MAX_GEN],DA1[MAX_GEN],DA2[MAX_GEN];
  int   MECH[MAX_GEN],STATUS[MAX_GEN];
} GEN_PARTICLE;
extern GEN_PARTICLE gen_particle; // ntuple.cc
static GEN_PARTICLE gen_particle_clear; // Zero components

static char  s_gen_particle[] = 
"NGEN:I::[0,20], "
"XX(NGEN):R, YY(NGEN):R, ZZ(NGEN):R, "
"PX(NGEN):R, PY(NGEN):R, PZ(NGEN):R, PP(NGEN):R, EK(NGEN):R, MASS(NGEN):R, "
"PN(NGEN):I::[0,100], "
"MO(NGEN):I::[0,20], DA1(NGEN):I::[-1,20], DA2(NGEN):I::[-1,20], "
"MECH(NGEN):I, STATUS(NGEN):I";


// GSIM_RAND
typedef struct{
  int   SEED1,SEED2;
} GSIM_RAND;
extern GSIM_RAND gsim_rand; // ntuple.cc
static GSIM_RAND gsim_rand_clear; // Zero components

static char  s_gsim_rand[] = 
"SEED1:I, SEED2:I";


#endif // GSIM_GENERAL_NTUPLE_H_INCLUDED
