/* -*- C++ -*-
//
// g321common.h
// C/C++ interface of GEANT COMMON BLOCKS
//
// Author:  Mitsuhiro YAMAGA (yamaga@post.kek.jp)
// Created: Wed Jul 11 15:29:57 JST 2001
//
// $Id: G321Common.h,v 1.2 2003/01/21 06:22:20 yamaga Exp $
//
// Revision History
//
// $Log: G321Common.h,v $
// Revision 1.2  2003/01/21 06:22:20  yamaga
// Check CERN_LEVEL to cope with the MXGKIN in geant321/gckmax.inc
//
// Revision 1.1.1.1  2002/08/13 12:48:12  kensh
//
//
// Start version.
//
*/

#ifndef G321COMMON_H_INCLUDED
#define G321COMMON_H_INCLUDED

#ifdef __cplusplus
extern"C"{
#endif

  typedef struct{
    int  NMATE,NVOLUM,NROTM,NTMED,NTMULT,NTRACK,NPART,NSTMAX,NVERTX,NHEAD,NBIT;
  } COMMON_GCNUM;
  extern COMMON_GCNUM  gcnum_;

  typedef struct{
    int   IHSET,IHDET,ISET,IDET,IDTYPE,NVNAME,NUMBV[20];
  } COMMON_GCSETS;
  extern COMMON_GCSETS  gcsets_;

  typedef struct{
    int    IKINE;
    float  PKINE[10];
    int    ITRA,ISTAK,IVERT,IPART,ITRTYP,NAPART[5];
    float  AMASS,CHARGE,TLIFE,VERT[3],PVERT[4];
    int    IPAOLD;
  } COMMON_GCKINE;
  extern COMMON_GCKINE  gckine_;

#if (CERNLIB_VERSION>=2002)
#define MXGKIN 250 // include/geant321/gckmax.inc
#elif (CERNLIB_VERSION>0)
#define MXGKIN 100
#else
#error $CERN/$CERN_LEVEL not correctly set.
#endif
  typedef struct{
    int    KCASE,NGKINE;
    float  GKIN[MXGKIN][5],TOFD[MXGKIN];
    int    IFLGK[MXGKIN];
  } COMMON_GCKING;
  extern COMMON_GCKING  gcking_;
  
  typedef struct{
    int    IDEBUG,IDEMIN,IDEMAX,ITEST,IDRUN,IDEVT,IEORUN;
    int    IEOTRI,IEVENT,ISWIT[10],IFINIT[20],NEVENT,NRNDM[2];
  } COMMON_GCFLAG;
  extern COMMON_GCFLAG  gcflag_;
  
  typedef struct{
    float  PI,TWOPI,PIBY2,DEGRAD,RADDEG,CLIGHT,BIG,EMASS;
  } COMMON_GCONST;
  extern COMMON_GCONST  gconst_;

# define MAXMEC 30 // include/geant321/gctrak.inc
  typedef struct{
    float  VECT[7],GETOT,GEKIN,VOUT[7];
    int    NMEC,LMEC[MAXMEC],NAMEC[MAXMEC],NSTEP,MAXNST;
    float  DESTEP,DESTEL,SAFETY,SLENG,STEP,SNEXT,SFIELD,TOFG,GEKRAT,UPWGHT;
    int    IGNEXT,INWVOL,ISTOP,IGAUTO,IEKBIN,ILOSL,IMULL,INGOTO;
    int    NLDOWN,NLEVIN,NLVSAV,ISTORY;
  } COMMON_GCTRAK;
  extern COMMON_GCTRAK  gctrak_;

# define MAXME1 30
  typedef struct{
    float  POLAR[3];
    int    NAMEC1[MAXME1];
  } COMMON_GCTPOL;
  extern COMMON_GCTPOL  gctpol_;
 
  typedef struct{
    int    NLEVEL,NAMES[15],NUMBER[15],LVOLUM[15],LINDEX[15];
    int    INFROM,NLEVMX,NLDEV[15],LINMX[15];
    float  GTRAN[15][3],GRMAT[15][10],GONLY[15],GLX[3];
  } COMMON_GCVOLU;
  extern COMMON_GCVOLU  gcvolu_;
  

#ifdef __cplusplus
}
#endif


#endif //G321COMMON_H_INCLUDED
