/* -*- C -*-

   guwrite.c

   Author:  Mitsuhiro YAMAGA
   Created: Wed Dec 11 22:57:06 JST 2002

   $Id: guwrite.c,v 1.1 2002/12/11 14:12:33 yamaga Exp $

   Revision History

   $Log: guwrite.c,v $
   Revision 1.1  2002/12/11 14:12:33  yamaga
   Imported package.


*/
/*                    Grand Unified WRITE
         Switch multiple protocols by looking at the protocol field
         which start with / and end with : placed at the head of
         the file name.   Currently supported protocols are
         FS(file system) and HPSS(high performance storage system).

         /hpss:<hpss name>  -> invoke hpss calls for the file <hpss name>
         /:                 -> expanded to /.../cc.kek.jp/fs
                                              (hard wired for the momtne)
                               and use the system standard write call.
         anything else      -> use the system standard write call.

	 
	 This code based on the hpsscat.c provided by IBM Japan (2001/01/23).
         M. Aoki modified the base code (2001/01/23).
*/	 

static char rcsid_guwrite[] = "@(#) $Id: guwrite.c,v 1.1 2002/12/11 14:12:33 yamaga Exp $";


#include <stdio.h>
#include <errno.h>
#include <fcntl.h>
#include <string.h>
#include <ctype.h>
#include <sys/time.h>
#include "hpss_api.h"
#include "hpss_types.h"
#include "u_signed64.h"
#include "gufio/hpss_bufapi.h"
#include "gufio/gufio.h"


int guwrite(int fd, void *buf, size_t count)
{
  ssize_t size;
  struct gufio_tbl *thetbl;

  thetbl = gutblget(fd);
  if ( thetbl->ftype == GUFILE_HPSS ) {
    size = hpss_Bufwrite(thetbl->hfd, buf, count);
    while(size <= 0) {
      /*return(-1);*/ /* errno is supposed to be set by hpss_Bufwrite */
      gureopenall();
      size = hpss_Bufwrite(thetbl->hfd, buf, count);
    }
  } else {
    size = write(thetbl->hfd, buf, count);
    if ( size < 0 ) {
      return(-1); /* errno is supposed to be set by write */
    }
  }

  return(size);
}
