// -*- C++ -*-
//
// MTdcModule.cc
//
// Sun Dec  1 15:06:54 JST 2002
// Mitsuhiro YAMAGA
//
// $Id: MTdcModule.cc,v 1.1 2002/12/01 14:37:26 yamaga Exp $
//
// $Log: MTdcModule.cc,v $
// Revision 1.1  2002/12/01 14:37:26  yamaga
// Initial version for multihit TDC.
//
//
//

#include <iostream>
#include "unpack/MTdcModule.h"

//
MTdcModule::MTdcModule( int crate, int pa )
  : m_crate( crate ),
    m_pa( pa ),
    m_parity( -1 ),
    m_bufferNumber( -1 ),
    m_wordCount( 0 )
{
  //
}

//
MTdcModule::~MTdcModule()
{
  //
}

//
void
MTdcModule::show() const
{
  std::cout << "Crate#" << m_crate
            << " PA#" << m_pa 
            << " Header=" << std::hex << m_headerWord
            << std::dec << std::endl;
  //for( std::list<unsigned int>::const_iterator i = m_hitList.begin();
  //     i != m_hitList.end(); i++ ){
  //  std::cout << " " << std::hex << *i;
  //}
  for( int i=0;i<MAX_MTDC_CH;i++ ){
    int  nch = m_ch[i].size();
    for( int ch=0;ch<nch;ch++ ){
      std::cout << " ch"     << m_ch[i][ch].ch
                << " parity" << m_ch[i][ch].parity
                << " hitct"  << m_ch[i][ch].hitct
                << " edge"   << m_ch[i][ch].edge
                << " time"   << m_ch[i][ch].time
                << std::endl;
    }
  }
  std::cout << std::dec << std::endl;
}

//
std::ostream&
operator<<( std::ostream& out, const MTdcModule& m )
{
  out << "Crate#" << m.m_crate
      << " PA#" << m.m_pa << " :";
  for( int i=0;i<MAX_MTDC_CH;i++ ){
    int  nch = m.m_ch[i].size();
    for( int ch=0;ch<nch;ch++ ){
      out << " " <<  std::hex  << m.m_ch[i][ch].time << std::dec;
    }
  }
  
  return( out );
}
